<template>
  <div class="container">
      <div class="head">
        <img :src="goback" alt="" @click="onClickLeft()">
        <div class="title">发布新图板</div>
        <el-button class="send" @click="uploadNewBoard()">发布</el-button>
      </div>
      <div class="main">
        <el-input
          type="text"
          class="pt-title"
          placeholder="在此输入图板的标题"
          v-model="text"
          maxlength="30"
        >
        </el-input>
        <el-input
          type="textarea"
          class="pt-content"
          placeholder="在此填写相关的信息或者介绍，描述得越清晰，就能越快找到你的知音哦~"
          v-model="textarea"
          maxlength="140"
          autosize
        >
        </el-input>
        <div class="participants" style="margin-bottom:30px">
          <i class="el-icon-connection" style="line-height: 28px;margin-right:6px;color:#3170ff;font-weight:bold"></i>
          <div class="people">图板参与人数</div>
          <template>
            <el-input-number v-model="num1" @change="handleChange" :min="1" size="mini"></el-input-number>
          </template>
        </div>
        <div class="upload-pics">
          <ul class="upload-imgs">
            <li class="row-li" v-for='(value, key) in fileList' :key = key>
              <div class="img-container"><img class="show-img" :src="getPicUrl(value)" alt=" "></div>
              <a class="close" @click="delPic(key)"><img class="close" :src="deletepic" alt=""></a>
            </li>
            <li class="row-li" v-if='fileList.length>=3 ? false : true'>
              <div class="upload-demo" @click="uploadFile()">+</div>
            </li>
          </ul>
        </div>
        <el-dialog :visible.sync="dialogVisible">
          <img width="100%" :src="dialogImageUrl" alt="">
        </el-dialog>
      </div>
  </div>
</template>

<script>
import goback from '@/assets/goback.png'
import deletepic from '@/assets/detail/del_pic.png'
import { Toast } from 'vant'
export default {
  name: 'Upload',
  components: {},
  props: {},
  data () {
    return {
      goback,
      deletepic,
      text: '',
      textarea: '',
      dialogImageUrl: '',
      dialogVisible: false,
      fileList: [],
      fileUrl: [],
      formData:new FormData(),
      imgs: {},
      imgLen:0,
      num1: 1,
      userId: '',
      mes:''
    }
  },
  watch: {},
  computed: {},
  created () {},
  mounted () {},
  methods: {
    isNull (val) {
      var str = val.replace(/(^\s*)|(\s*$)/g, '') // 去除空格;

      // eslint-disable-next-line eqeqeq
      if (str === '' || str === undefined || str === null) {
        return true
      } else {
        return false
      }
    },
    handleChange(value) {
      console.log(value);
    },
    onClickLeft () {
      this.$router.back()
    },
    uploadFile: function () {
      // 此时可以自行将文件上传至服务器
      var input = document.createElement('input')
      input.type = 'file'
      input.click()

      var vueObj = this
      input.onchange = function () {
        var file = input.files[0]
        if (!file) {
          return
        }
        if ((file.type !== 'image/jpeg') && (file.type !== 'image/png') && (file.type !== 'image/gif,image/jpg') && (file.type !== 'image/jpg')) {
          Toast('请上传图片')
          return false
        }
        let fileName = vueObj.$api.uploadFile(file, '/board')
        var fileUrl = vueObj.$api.getFileUrl(fileName, '/board')
        vueObj.updateFileList(file, fileUrl)
      }
    },
    updateFileList (file, fileUrl) {
      if (!fileUrl) {
        Notification({
          title: '上传文件失败',
          position: 'top-right',
          type: 'error'
        })
      }
      if (this.fileList.length > 3) {
        Toast('上传数量超过界限')
      } else {
        this.fileUrl.push(fileUrl)
        this.fileList.push(file)
        console.log(this.fileList, this.fileUrl)
        console.log(file)
      }
    },
    getPicUrl (file) {
      var show = null
      if (window.createObjectURL !== undefined) { // basic
        show = window.createObjectURL(file)
      } else if (window.URL !== undefined) { // mozilla(firefox)
        show = window.URL.createObjectURL(file)
      } else if (window.webkitURL !== undefined) { // webkit or chrome
        show = window.webkitURL.createObjectURL(file)
      }
      return show
    },
    delPic (key) {
      this.$delete(this.fileList, key)
      this.$delete(this.fileUrl, key)
      this.imgLen--
      console.log(this.fileList, this.fileUrl)
    },
    uploadNewBoard: async function () {
      this.userId = window.localStorage.getItem('userId')
      console.log(this.userId)
      console.log(this.fileUrl)
      console.log(this.textarea)
      console.log(this.text)
      if (!this.text) {
        Toast('请输入标题')
        return
      }
      if (!this.textarea) {
        Toast('请输入内容')
        return
      }
      this.mes = await this.$api.postNewBoard(this.textarea, this.fileUrl, this.text, this.num1, this.userId)
      console.log(this.mes)
      if (this.mes.data.code === 200) {
        Toast('发布成功')
        this.fileList = []
        this.fileUrl = []
        this.$router.back()
      } else {
        Toast(this.mes.data.message)
        this.fileUrl = []
        this.fileList = []
      }
/*      this.$api.postNewBoard(this.textarea, this.fileUrl, this.text, this.num1, this.userId)
        .then(_ => {
          Toast('发布成功')
          this.fileList = []
          this.fileUrl = []
          this.$router.back()
        }).catch(() => {
          Toast('发布失败')
          this.fileUrl = []
          this.fileList = []
        })*/
    }
  }
}
</script>
<style lang="less" scoped>
.container {
    display: flex;
    flex-direction: column;
    .head{
      position:fixed;
      top:0;
      display:flex;
      align-items: center;
      background:#fff;
      width:100%;
      height:57.5px;
      img{
          position: absolute;
          top:20.5px;
          left:5.47%;
          width:13.5px;
          height:18.5px;
      }
      .title{
          flex:1;
          text-align: center;
          font-size:15.3px;
          font-weight:bold;
          color:#4d4d4d;
          letter-spacing: 6px;
          text-indent: 6px;
      }
      .send{
          position: fixed;
          top:16.5px;
          right:4.4%;
          background:#3170FF;
          width:54.5px;
          height:29px;
          border-radius: 4px;
          font-size:14.4px;
          color:#fff;
          font-weight:bold;
          display: flex;
          justify-content: center;
          letter-spacing: 4px;
          text-indent: 4px;
          padding:0;
      }
    }
    .main{
      margin-top:59.5px;
      background: #fff;
      padding:32px 10%;
      .pt-title{
          margin-bottom:29.5px;
          /deep/.el-input__inner{
            border:none;
            color:#666666;
            font-weight:bold;
            font-size:15.5px;
            letter-spacing:2px;
            padding:0;
          }
      }
      .pt-content{
          margin-bottom:37px;
          /deep/.el-textarea__inner{
            border:none;
            color:#999999;
            font-weight:normal;
            font-size:15.5px;
            letter-spacing:2px;
            padding:0;
            min-height:100px !important;
          }
      }
      .participants{
        display: flex;
        flex-direction: row;
        .people{
          flex:1;
          color:#C2C2C2;
          font-weight:normal;
          font-size:14px;
          line-height: 28px;
          vertical-align: bottom;
        }
        /deep/.el-input-number--mini{
          width:90px;
        }
        /deep/.el-input-number__decrease:hover:not(.is-disabled)~.el-input .el-input__inner:not(.is-disabled){
          border-color:#DCDFE6;
        }
        /deep/.el-input-number__increase:hover:not(.is-disabled)~.el-input .el-input__inner:not(.is-disabled){
          border-color:#DCDFE6;
        }
        /deep/.el-input__inner:hover {
          border-color: #DCDFE6;
        }
      }
      .upload-demo{
        width:80.5px;
        height:80.5px;
        border:#D2D2D2 0.5px solid;
        border-radius: 3px;
        display: flex;
        align-items: center;
        justify-content: center;
        color: #E5E5E5;
        font-size:25px;
        font-weight:bolder;
      }
      .img-container{
        overflow: hidden;
        width:80.5px;
        height:80.5px;
        display: inline-block;
        border:#D2D2D2 0.5px solid;
        border-radius: 3px;
      }
      .row-li{
        float: left;
        position: relative;
        margin-right: 18.5px;
      }
      .close{
        display: none;
      }
      .row-li:hover .close{
        display: block;
        position: absolute;
        width: 20px;
        height:20px;
        right: -4px;
        top: -4px;
        z-index: 999;
      }
      .show-img{
        width: 80.5px;
        height: 80.5px;
        object-fit: cover;
        overflow: hidden;
        border:#D2D2D2 0.5px solid;
      }
    }
}
</style>
